//
//  Uninstall DLL called by InstallShield's Uninst.Exe.  This DLL inturn loads
//  and runs the DLL to remove NetQuestion and ICS Lite.
//
//  created 05/05/97 Rodney Thomas
//
//////////////////////////////////////////////////////////////////////////////
//  IBM Confidential                                                        //
//  OCO Source Materials                                                    //
//  5622-902                                                                //
//  (C) Copyright IBM Corp. 1997                                            //
//  All rights reserved.                                                    //
//  The source code for this program is not published or otherwise          //
//  divested of its trade secrets, irrespective of what has been            //
//  deposited with the U.S. Copyright Office.                               //
//                                                                          //
//  U.S. Government Users Restricted Rights -                               //
//  Use, duplication or disclosure restricted by                            //
//  GSA ADP Schedule Contract with IBM Corp.                                //
//////////////////////////////////////////////////////////////////////////////
/*****************************************************************************
CHANGE-ACTIVITY:

FLAG REASON   RELEASE   DATE     ORIGIN   FLAG DESCRIPTORS
---- -------- -------   ------   ------   ---------------------------------------
                        21/05/97 npf      added support for including .c file

*****************************************************************************/
#ifndef _WINDOWS_
#include <windows.h>
#endif // _WINDOWS
#include <io.h>

//*******
//*******   Include the function declaration!
//*******

// Function declaration
BOOL RemoveNetQuestion( void );


//HINSTANCE   globalHInstance;



#ifndef _NETQ_INCLUDE_

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
//      globalHInstance = hinstDLL;
 	return (1);
}

_declspec(dllexport) LONG APIENTRY UninstInitialize(HWND hwndDlg,HANDLE hInstance,LONG lRes)
{
   return 1;
}


_declspec(dllexport) LONG APIENTRY UninstUnInitialize(HWND hwndDlg,HANDLE hInstance,LONG lRes)
{
   return RemoveNetQuestion();
}

#endif // _NETQ_INCLUDE_

//*******
//*******   Include the function below!
//*******
BOOL RemoveNetQuestion()
{
   // NetQuestion installed directory
   #define REG_NETQ_INSTALL_DIR        "SOFTWARE\\IBM\\NetQuestion\\CurrentVersion\\Installation Directory"
   #define REG_NETQ_INSTALL_DIR_NAME   "Directory"
   #define UNINSTALL_NETQ_DLL          "\\uninstnq.dll"
   #define UNINSTALL_NETQ_FUNC         "UninstallNetQuestion"
   #define NETQ_MAX_PATH_LEN           256

   DWORD          rc = 0;
   DWORD          value_type;
   HKEY           hkey;
   DWORD          size = NETQ_MAX_PATH_LEN;
   char           uninstNetQDLL[NETQ_MAX_PATH_LEN];
   HINSTANCE      hUninstNetQDLL;
   typedef LONG   (* FuncPtr)();
   FuncPtr        UninstallNetQuestion;
   BOOL           result;


   rc = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
                     REG_NETQ_INSTALL_DIR,     // SubKey Registration Path
                     0L,                       // Reserved
                     KEY_READ,                 // samDesired
                     &hkey);                   // handle for opened key

   // If the registry key does not exist, then there is nothing to remove/uninstall.
   if ( rc != ERROR_SUCCESS )
      return 1;

   value_type = REG_SZ;

   rc = RegQueryValueEx(hkey,                  // handle of key to set value for
                        REG_NETQ_INSTALL_DIR_NAME, // Value name
                        0L,                    // Reserved
                        &value_type,           // Value type
                        (LPBYTE)uninstNetQDLL, // Value data
                        &size);                // Address of data size

   RegCloseKey(hkey);

   // Create the full path filename for the DLL
   strcat( uninstNetQDLL, UNINSTALL_NETQ_DLL );

   hUninstNetQDLL = LoadLibrary( uninstNetQDLL );

   UninstallNetQuestion = (FuncPtr)GetProcAddress(hUninstNetQDLL, UNINSTALL_NETQ_FUNC);

   result = UninstallNetQuestion();  // Uninstall/remove NetQuestion and ICS Lite

   FreeLibrary( hUninstNetQDLL );

   // remove unistall library if NetQuestion was uninstalled

   if( result )
   {
	   _unlink( uninstNetQDLL );
   }

   return 1;

   #undef REG_NETQ_INSTALL_DIR
   #undef REG_NETQ_INSTALL_DIR_NAME
   #undef UNINSTALL_NETQ_DLL
   #undef UNINSTALL_FUNC_NAME
   #undef NETQ_MAX_PATH_LEN
}
